General
Di_Library is designed as a set of drop-in replacements for the basic
xBase user input/output commands.  Such replacements are intended to
allow for easy porting of existing xBase terminal-based applications to
World Wide Web CGI applications.  In addition to close equivalents of
xBase input/output commands, di_Library contains (or will contain) a
collection of functions for HTML specific features, CGI control, and
device manipulation.  The specific intended strength of di_Library is
that it allows the use of identical functions for input/output from/to
both the terminal and a web-browser.  Common source code, and even in
many cases a common executable, can be used to interface whatever user
input/output device is used to access common underlying business logic.
In the future, di_Library might include access to more device types in
addition to the screen and a web-browser.  The Norton Guide you are
currently viewing contains the documentation for di_Library version 0.1
(alpha).

Di_Library is written entirely in Clipper 5.3.  Full source code
accompanies each distribution of the library.  While I do not expect any
difficulty in compiling and using di_Library for other xBase
environments and compilers than Clipper 5.3, no warranty is made or
expressed as to such compatibility.  In addition, no warranty is made or
expressed as to the suitability or usability of di_Library for any
purpose.

di_Library vs. other libraries
Other libraries created to assist in creating xBase CGI server apps have
a somewhat different focus than di_Library.  I know of two such products
currently:  FiveWeb and Webtools.  Both of these libraries are directed
at developers who wish to create new CGI applications in xBase.  They
provide HTML-centric output functions to allow the use a web-browser as
an interface to xBase applications.  Although di_Library can also be
used for the creation of new CGI applications using familiar xBase
structures, its strength lies in the retro-fitting or "dual-fitting" of
legacy xBase applications.  Rather than design user input/output
functions which are specific to HTML, di_Library creates functions
closely matching the syntax of existing xBase commands, but with an
underlying device-independence.  A di_Library developer wishing to put
existing applications on to the Web needs not rewrite all the user
interface actions from scratch, as with other libraries, but simply
search for individual @SAY's, @GET's and so on, and replace them with
syntactically similar di_Library functions.  After such replacement, the
source code (and the executable!) retain the ability to function
unchanged as terminal-based applications.  See the Examples sections, as
well as the DEMO.EXE module for examples of how this can work.

Registration of di_Library
Di_Library is the property of David Mertz.  Registration of di_Library
is required.  For version 0.1, di_Library is postcard-ware.  Send a
postcard (or letter, or email) to David Mertz at the below listed
address for unlimited usage rights to di_Library (v0.1).  Any feedback
on the usefulness, functionality, or suggestions as to features which
should be added, would be greatly appreciated.  Di_Library may not be
resold for profit without the express permission of David Mertz.
However, the free distribution of the file DI_LIB.ZIP is encouraged, as
long as the archive retains all files in the original distribution.
Probably di_Library will remain (almost) free for personal, educational
and non-profit use; probably it will start costing something for
commercial use before it goes Gold.  Registration of version 0.1 does
not entail a registrant to any rights to any future versions.

        David Mertz
        99 Second Street
        Turners Falls, MA 01376-1313
        quilty@philos.umass.edu

Anticipated schedule of di_Library features
In general, each scheduled feature is anticipated to be completed no
later than in the version number in which it is indicated.  Changes in
functionality may be made during the course of Alpha/Beta development in
response to user feedback and/or reevaluation by the programmer.
However, the basic goals of implementing a drop-in replacement
output-neutral input/output system for Clipper, with particular focus on
enabling Web access, shall be retained.  Understandably, I get a bit
less specific as versions go up.

Library functions intended for use by third party programmers are named
in the manner di_FUNCNAME(); functions intended primarily for internal
use by di_Library are named as _diFUNCNAME().  In Alphas and Betas it
may be necessary to use internal functions to achieve certain results
which will be possible in later version using only the (more
error-resistant) user functions.

    0.1
    Implementation of most basic Clipper user input/output primitives,
    and general functions used to reference devices:

    0.2
    Implementation of additional Clipper i/o elements:  Additional input
    controls.
        di_GetList()             // Replacement for @..GET LISTBOX
        di_GetCheck()            // Replacement for @..GET CHECKBOX
        di_GetPush()             // Replacement for @..GET PUSHBUTTON
        di_GetRadio()            // Replacement for @..GET RADIOGROUP

    0.3-0.5
    Implementation of more complicated Clipper i/o elements:  Table and
    menu controls.
        di_Prompt()              // Replacements for PROMPT/MENU TO
        di_MenuTo()              //    menuing system
        di_TBrowse()             // Replacement for DB display object
        di_TopBar()              // Replacement for TopBar object
        di_PopUp()               // Replacement for Popup object

    0.6-0.7
    Implementation of CGI specific functions.  Need to create functions
    to parse CGI parameters, deal with CGI environment variables,
    implement hooks for web-server specifics.  Possibly implement some
    detection of web-browser feature sets.

    0.8
    Creation of higher level input/output functions.  Such custom
    functions would not be drop-in replacements for native Clipper
    commands and functions, but would provide ready methods of
    performing the most used i/o activities in an output-neutral manner.

    0.9
    Creation of additional functions specific to HTML layout and
    presentation.  These functions will not be output-neutral, but will
    allow specific tweaking of the appearance of created web pages.

    1.0
    Any final bug-fixes and gap filling which arises during Betas.
    Creation of a feature-stable packaged product for wider distribution
    efforts.

