*-------------------------------------------------------------------------
FUNCTION _diActiveDevice(nDevice)	// --> lActive
*-------------------------------------------------------------------------
//-- Determine if a given device is active by calling _diInitDevice()
	* Parameter is single device whose status is being checked
	* Invalid (empty) argument returns value FALSE

LOCAL nDeviceList, i := 0, nExp, lArgValid := .F.

*** ? "_diActiveDevice(",nDevice,")"

DO WHILE .NOT. lArgValid		// Spend a little time making sure argument
	IF 2^i = nDevice			//    is valid (i.e. nDevice = 2^n)
		lArgValid := .T.
	ELSEIF i++ > MaxDevices
		RETURN .F.
	ENDIF
ENDDO

nDeviceList := _diInitDevice()	// Fetch nDeviceList (sum of devices)

IF nDevice > nDeviceList		// No device >=  nDevice is in list
	RETURN .F.
ELSE							// Decrement devices > nDevice from list
	i := MaxDevices
	DO WHILE (nExp := 2^i--) > nDevice
		nDeviceList -= IIF( (nDeviceList >= nExp), nExp, 0 )
	ENDDO
								// Return .T. IFF nDevice >= decremented list
	RETURN IIF( (nDevice <= nDeviceList), .T., .F. )
ENDIF


