*-------------------------------------------------------------------------
FUNCTION di_BOX(nTop,nLeft,nBottom,nRight,cBoxString,cColor)
												// --> nSuccessList
*-------------------------------------------------------------------------
//-- Replacement for @..BOX command to output to multiple device types
	* Parameters are Top, Left, Bottom, Right, BoxString, [Color]
	* Returns the list of devices successfully written to

LOCAL nSuccessList := 0, i, j, nExp, nBeg, nPar, nOutputList,  ;
		cMarker, cPage,  lPrev

								// If no arguments, do nothing, return 0
IF EMPTY(nTop) .OR. EMPTY(nLeft) .OR. EMPTY(nBottom) .OR. ;
				EMPTY(nRight) .OR. EMPTY(cBoxString)
	RETURN 0
ENDIF

nOutputList := di_SetOutput()	// For each device, check status
								// If device 1 (screen) outputs, implement
								//    a standard @..BOX block
IF nOutputList/2 <> INT(nOutputList/2)
								// Make sure SAY is  within screen area
	IF  (nTop >= 0) .AND. (nLeft>= 0) .AND. ;
		(nLeft<= MAXCOL()) .AND. (nBottom <= MAXROW()) .AND. ;
		(nBottom >= nTop) .AND. (nRight >= nLeft)
		nSuccessList += 1		// Add screen to nSuccessList
								// Fill in generic values if cPict
								//    or cColor are empty
		cColor:= IIF( EMPTY(cColor), SETCOLOR(), cColor )
		@ nTop, nLeft, nBottom, nRight BOX cBoxString COLOR cColor
	ENDIF
ENDIF
								// If nOutputList happens to have any reserved
								//   devices beyond HTML, remove them
nOutputList := _diJustHTML(nOutputList)
								// For each HTML device, do the BOX
								// Step through possible HTML devices
FOR i = MaxHTMLDevice TO 1 STEP -1
								// If device 2^i set to output, remove
								// 2^i from the output list and proceed
								// with attempted modification
	IF nOutputList >= (nExp := 2^i)
		nOutputList -= nExp		// Decrement nOutputlist and fetch the page
		cPage := _diHTMLEdit(nExp)
		lPrev := .F.			// Assume no relevant marker found
								// Look for position marker < nTop
		j := nTop				// Start looking from specified top row
								// Try to find previous position maker
		DO WHILE j-- > 0 .AND. .NOT. lPrev
			cMarker := "<!-- "+STR(j,3)
			IF 0 <> (nBeg := AT(cMarker,cPage))
				lPrev := .T.
								// If the <HR> is closely followed by a <P>,
								//   eliminate said <P>
				IF 0 = (nPar := AT("<P>",SUBSTR(cPage,nBeg+15,20)))
					cPage := SUBSTR(cPage,1,nBeg+14) + crlf + "<HR>" + ;
							"<!-- " + STR(nTop,3)+ "TOP -->" + ;
							SUBSTR(cPage,nBeg+15)
				ELSE
					cPage := SUBSTR(cPage,1,nBeg+14) + crlf + "<HR>" + ;
							"<!-- " + STR(nTop,3)+ "TOP -->" + crlf + ;
							SUBSTR(cPage,nBeg+15+nPar+2)
				ENDIF
				cPage := _diHTMLEdit(nExp,cPage)
			ENDIF
		ENDDO
							// If no marker < nTop put <HR> at start of page
		IF .NOT. lPrev		// If no position marker, use '<BODY>'
			cMarker := "<BODY>"
			IF 0 <> (nBeg := AT(cMarker,cPage))
				lPrev := .T.
								// If the <HR> is closely followed by a <P>,
								//   eliminate said <P>
				IF 0 = (nPar := AT("<P>",SUBSTR(cPage,nBeg+6,20)))
					cPage := SUBSTR(cPage,1,nBeg+5) + crlf + "<HR>" + ;
							"<!-- " + STR(nTop,3)+ "TOP -->" + ;
							SUBSTR(cPage,nBeg+6)
				ELSE
					cPage := SUBSTR(cPage,1,nBeg+5) + crlf + "<HR>" + ;
							"<!-- " + STR(nTop,3)+ "TOP -->" + crlf + ;
							SUBSTR(cPage,nBeg+6+nPar+2)
				ENDIF
				cPage := _diHTMLEdit(nExp,cPage)
			ENDIF
		ENDIF
		lPrev := .F.			// Assume no relevant marker found
								// (we just wrote a lower line # marker)
		j := nBottom			// Start looking from specified BOTTOM row
								// Try to find previous position maker
		DO WHILE j-- > 0 .AND. .NOT. lPrev
			cMarker := "<!-- "+STR(j,3)
			IF 0 <> (nBeg := AT(cMarker,cPage))
				lPrev := .T.
				cPage := SUBSTR(cPage,1,nBeg+14) + crlf + "<HR>" + ;
						"<!-- " + STR(nBottom,3)+ "BOT -->" + ;
						SUBSTR(cPage,nBeg+15)
				cPage := _diHTMLEdit(nExp,cPage)
			ENDIF
		ENDDO
							// If something found for starting marker,
							//   add current page to nSuccessList
		nSuccessList += IIF( lPrev, nExp, 0)
	ENDIF
NEXT i

RETURN nSuccessList

