*-------------------------------------------------------------------------
FUNCTION di_GET(nTop, nLeft, cVarName, cPict, cColor, cCaption, ;
					 cMessage, cWhen, cRange, cValid, cSend, cGUISend)
													// --> nSuccessList
*-------------------------------------------------------------------------
//-- Replacement for @..GET command to input from multiple device types
	* Parameters are Top, Left, VarName, Picture, Color, Caption,
	*    Message, When, Range, Valid, Send, GUISend
	* VarName is a string naming the variable, NOT the variable GET'ing
	*    i.e. call di_GET(..., 'myVar',...), not di_GET(..., myVar, ...)
	*    The variable named in cVarName MUST be PUBLIC or PRIVATE
	* Returns the list of devices successfully written to

LOCAL nSuccessList := 0, i, j, nExp, nBeg, nEnd, nLast, nOutputList,  ;
		cMarker, cPage, cEnd, lPrev, oGet, nLow, nHigh, cScreen, ;
		cInputString,cLength

								// If no arguments, do nothing, return 0
IF EMPTY(nTop) .OR. EMPTY(nLeft) .OR. EMPTY(cVarName)
	RETURN 0
ENDIF

nOutputList := di_SetOutput()	// For each device, check status

								// If device 1 (screen) outputs, add
								//    a get object to the GETLIST
IF nOutputList/2 <> INT(nOutputList/2)
								// Make sure GET is  within screen area
	IF  (nTop >= 0) .AND. (nTop <= MAXROW()) .AND. ;
		(nLeft>= 0) .AND. (nLeft<= MAXCOL())
		nSuccessList += 1		// Add screen to nSuccessList
								// Little kludge if PICT changes GET width
		cScreen := SAVESCREEN(nTop,nLeft,nTop,MAXCOL())
								// Let's add a GET object to the GETLIST,
								// and set the exported instance variables
		@ nTop, nLeft GET &cVarName
		oGet := ATAIL(GETLIST)
		IF .NOT. EMPTY(cPict)
			oGet:PICTURE := cPict
		ENDIF
		oGet:COLORSPEC := IIF( EMPTY(cColor), SETCOLOR(), cColor )
		IF .NOT. EMPTY(cMessage)
			oGet:MESSAGE := cMessage
		ENDIF
		IF .NOT. EMPTY(cWhen)	// Valid string must be changed a bit
			cWhen := "{  |oGet| "+cWhen+ "}"
			oGet:PREBLOCK := &cWhen
		ENDIF
		IF .NOT. EMPTY(cRange)	// Interpret RANGE in POSTBLOCK
			IF 0 <> (nBeg := AT(",",cRange))
				nLow  := STR(VAL(SUBSTR(cRange,1,nBeg-1)))
				nHigh := STR(VAL(SUBSTR(cRange,nBeg+1)))
				cRange := "{ |oGet| (" +nLow+  "<=" +cVarName+ " .AND. " ;
									   +nHigh+ ">=" +cVarName+ ") }"
				oGet:POSTBLOCK := &cRange
			ENDIF
		ENDIF
		IF .NOT. EMPTY(cValid)	// Valid string must be changed a bit
			cValid := "{  |oGet| "+cValid+ "}"
			oGet:POSTBLOCK := &cValid
		ENDIF
		RESTSCREEN(nTop,nLeft,nTop,MAXCOL(),cScreen)
		oGet:DISPLAY()
	ENDIF
ENDIF
								// If nOutputList happens to have any reserved
								//   devices beyond HTML, remove them
nOutputList := _diJustHTML(nOutputList)
								// Set up field input string
cInputString := '<INPUT NAME="' +cVarName+ '" SIZE=' + ;
				STR(LEN(ALLTRIM(TRANSFORM(&cVarName,"@!")))+2)+ '>'
								// Step through possible HTML devices
FOR i = MaxHTMLDevice TO 1 STEP -1
								// If device 2^i set to output, remove
								// 2^i from the output list and proceed
								// with attempted modification
	IF nOutputList >= (nExp := 2^i)
		nOutputList -= nExp		// Decrement nOutputlist and fetch the page
		cPage := _diHTMLEdit(nExp)
		lPrev := .F.			// Assume no relevant marker found
								// First look for position marker nTop
		cMarker := "<!-- "+STR(nTop,3)
		nLast := 0				// Set last such marker to 0
		cEnd := cPage			// Loop while we keep finding cMarker
		DO WHILE 0 <> (nBeg := AT(cMarker,cEnd))
			IF VAL(SUBSTR(cEnd,nBeg+8,3)) < nLeft
				nLast += nBeg	// If this marker has lower column than nLeft,
								//	  need to keep looking for later marker
			ENDIF
								// Set cEnd to end part of cString (of last cEnd)
			cEnd := SUBSTR(cEnd,nBeg+14)
		ENDDO
		IF nLast <> 0			// If we found a matching row, with lower
								//    matching column, write cString there
			lPrev := .T.
			cPage := SUBSTR(cPage,1,nLast+14) + crlf + cInputString + ;
					"<!-- " + STR(nTop,3)+STR(nLeft,3)+ " -->" + ;
					SUBSTR(cPage,nLast+15)
			cPage := _diHTMLEdit(nExp,cPage)
		ENDIF

								// Next look for position marker < nTop
		j := nTop				// Start looking from specified row
								// Try to find previous position maker
		DO WHILE j-- > 0 .AND. .NOT. lPrev
			cMarker := "<!-- "+STR(j,3)
			IF 0 <> (nBeg := AT(cMarker,cPage))
				lPrev := .T.
				cPage := SUBSTR(cPage,1,nBeg+14) + crlf + "<P>"+ cInputString + ;
						"<!-- " + STR(nTop,3)+STR(nLeft,3)+ " -->" + ;
						SUBSTR(cPage,nBeg+15)
				cPage := _diHTMLEdit(nExp,cPage)
			ENDIF
		ENDDO
							// Last put cString at begining of page
		IF .NOT. lPrev		// If no position marker, use '<BODY>'
			cMarker := "<BODY>"
			IF 0 <> (nBeg := AT(cMarker,cPage))
				lPrev := .T.
				cPage := SUBSTR(cPage,1,nBeg+5) + crlf + "<P>" + cInputString + ;
						"<!-- " + STR(nTop,3)+STR(nLeft,3)+ " -->" + ;
						SUBSTR(cPage,nBeg+6)
				cPage := _diHTMLEdit(nExp,cPage)
			ENDIF
		ENDIF
							// If something found for starting marker,
							//   add current page to nSuccessList
		nSuccessList += IIF( lPrev, nExp, 0)
	ENDIF
NEXT i

RETURN nSuccessList
