*-------------------------------------------------------------------------
FUNCTION di_HTML2Ascii(cString)				// --> cString
*-------------------------------------------------------------------------
//-- Convert any HTML character entity names to ASCII characters
	* i.e. &lt; becomes '<'

local i := 0, j, k, cTemp
STATIC aConvert := { {'&','&amp;'}, ;
                     {'<','&lt;'}, {'>','&gt;'}, {'"','&quot;'}, ;
                     {'','&Ccedil;'}, ;
                     {'','&uuml;'}, ;
                     {'','&eacute;'}, ;
                     {'','&acirc;'}, ;
                     {'','&auml;'}, ;
                     {'','&agrave;'}, ;
                     {'','&ccedil;'}, ;
                     {'','&ecirc;'}, ;
                     {'','&euml;'}, ;
                     {'','&egrave;'}, ;
                     {'','&iuml;'}, ;
                     {'','&icirc;'}, ;
                     {'','&igrave;'}, ;
                     {'','&Auml;'}, ;
                     {'','&Aring;'}, ;
                     {'','&Eacute;'}, ;
                     {'','&ocirc;'}, ;
                     {'','&ouml;'}, ;
                     {'','&grave;'}, ;
                     {'','&ucirc;'}, ;
                     {'','&ugrave;'}, ;
                     {'','&yuml;'}, ;
                     {'','&Ouml;'}, ;
                     {'','&Uuml;'}, ;
                     {'','&cent;'}, ;
                     {'','&pound;'}, ;
                     {'','&yen;'}, ;
                     {'','&aacute;'}, ;
                     {'','&iacute;'}, ;
                     {'','&oacute;'}, ;
                     {'','&uacute;'}, ;
                     {'','&ntilde;'}, ;
                     {'','&Ntilde;'}, ;
                     {'','&ordf;'}, ;
                     {'','&ordm;'}, ;
                     {'','&iquest;'}, ;
                     {'','&not;'}, ;
                     {'','&frac12;'}, ;
                     {'','&frac14;'}, ;
                     {'','&iexcl;'}, ;
                     {'','&laquo;'}, ;
                     {'','&raquo;'}, ;
                     {'','&szlig;'}, ;
                     {'','&plusmn;'}, ;
                     {'','&divide;'}, ;
                     {'','&deg;'}, ;
                     {'','&middot;'}, ;
                     {'','&sup2;'} }

DO WHILE ++i <= LEN(cString)

    IF SUBSTR(cString, i, 1) != '&'
        LOOP
    ENDIF

*----------------------------------------------------------------
* k is the relative position of ';' with respect to '&'.  This
* information is then used to extract a substring of appropriate
* length (i.e. k) from cString and assign it to cTemp.
*----------------------------------------------------------------

cTemp := SUBSTR(cString, i, k := AT(';', SUBSTR(cString, i, 8) ) )

    IF (j := ASCAN(aConvert, {|aTemp| aTemp[2] = cTemp} ) ) > 0
        cString := STUFF(cString, i, k, aConvert[j, 1])
    ENDIF

ENDDO

RETURN cString


