*-------------------------------------------------------------------------
FUNCTION di_HTMLChars(cString)				// --> cString
*-------------------------------------------------------------------------
//-- Convert any special characters to HTML encoding
	* i.e. '<' becomes &lt;

local i := 0, j, k, cTemp
STATIC aConvert := { {'&','&amp;'}, ;
                     {'<','&lt;'}, {'>','&gt;'}, {'"','&quot;'}, ;
                     {'','&Ccedil;'}, ;
                     {'','&uuml;'}, ;
                     {'','&eacute;'}, ;
                     {'','&acirc;'}, ;
                     {'','&auml;'}, ;
                     {'','&agrave;'}, ;
                     {'','&ccedil;'}, ;
                     {'','&ecirc;'}, ;
                     {'','&euml;'}, ;
                     {'','&egrave;'}, ;
                     {'','&iuml;'}, ;
                     {'','&icirc;'}, ;
                     {'','&igrave;'}, ;
                     {'','&Auml;'}, ;
                     {'','&Aring;'}, ;
                     {'','&Eacute;'}, ;
                     {'','&ocirc;'}, ;
                     {'','&ouml;'}, ;
                     {'','&grave;'}, ;
                     {'','&ucirc;'}, ;
                     {'','&ugrave;'}, ;
                     {'','&yuml;'}, ;
                     {'','&Ouml;'}, ;
                     {'','&Uuml;'}, ;
                     {'','&cent;'}, ;
                     {'','&pound;'}, ;
                     {'','&yen;'}, ;
                     {'','&aacute;'}, ;
                     {'','&iacute;'}, ;
                     {'','&oacute;'}, ;
                     {'','&uacute;'}, ;
                     {'','&ntilde;'}, ;
                     {'','&Ntilde;'}, ;
                     {'','&ordf;'}, ;
                     {'','&ordm;'}, ;
                     {'','&iquest;'}, ;
                     {'','&not;'}, ;
                     {'','&frac12;'}, ;
                     {'','&frac14;'}, ;
                     {'','&iexcl;'}, ;
                     {'','&laquo;'}, ;
                     {'','&raquo;'}, ;
                     {'','&szlig;'}, ;
                     {'','&plusmn;'}, ;
                     {'','&divide;'}, ;
                     {'','&deg;'}, ;
                     {'','&middot;'}, ;
                     {'','&sup2;'} }

DO WHILE ++i <= LEN(cString)

	cTemp := SUBSTR(cString, i, 1)

	* ------------------------------------------------------------------------
	* The following IF block checks if there is an HTML character entity name
	* in cString to avoid converting its & to '&amp'.  If the i-th character
	* is '&', we look for a ';' within the next eigth characters and assign
	* its position relative to '&' to the variable k.  (If there is no ';',
	* then k is 0.)  If these two conditions hold, we scan the array aConvert
	* for the string between '&' and ';'.  If this string is equal to one of
	* the HTML character entity names, the pointer i for cString is increased
	* by the length of the entity name, and the execution branches to the
	* beginning of the DO WHILE loop.
	* ------------------------------------------------------------------------

	IF cTemp = '&' .AND. (k := AT(';', SUBSTR(cString, i, 8) )) > 0 .AND. ;
		ASCAN(aConvert, {|aTemp| aTemp[2] = SUBSTR(cString,i,k)}) > 0
		i += (k-1)
		LOOP
	ENDIF

	* ------------------------------------------------------------------------
	* The following IF block scans the array aConvert for the i-th character
	* of cString.  If it is equal to one of the special characters contained
	* in aConvert, it is deleted and replaced by the corresponding HTML
	* character entity name and the pointer i for cString is increased by
	* the length of the entity name.
	* ------------------------------------------------------------------------

    IF (j := ASCAN(aConvert, {|aTemp| aTemp[1] = cTemp})) > 0
        cString := STUFF(cString, i, 1, aConvert[j, 2])
        i += LEN(aConvert[j, 2]) - 1
    ENDIF

ENDDO

RETURN cString

