*-------------------------------------------------------------------------
FUNCTION _diInitDevice(nDevice)		// --> nInitDevices
*-------------------------------------------------------------------------
//-- Enable/Disable access to devices or examine accesses (INTERNAL)
	* Parameter is single device to be enabled/disabled (i.e. +/- 2^n)
	* Parameter of 0 uninitializes all (initializable) devices
	* Returns sum of all initialized devices
	* Device 1 (screen) is always initialized;
	*     (therefore: non-error return value is always >= 1)
	* Invalid (and out-of-bound) argument returns value 0
	* Positive value enables device, negative disables device

STATIC nInitDevices := 1
LOCAL i, nExp, lGoodArg := .F., nTmpInit, lDeviceActive

nTmpInit := nInitDevices

IF EMPTY(nDevice)				// Empty arg returns existing init state
	RETURN nInitDevices
ELSEIF nDevice > 2^MaxDevices	// Out-of-bounds init returns 0
	RETURN 0
ELSEIF nDevice = 0				// 0 argument uninitializes all devices
	RETURN (nInitDevices := 1)
ELSE
	FOR i = MaxDevices TO 0 STEP -1
		nExp := 2^i
		IF nTmpInit >= nExp		// nInitDevices contains device 2^i
			nTmpInit -= nExp
			lDeviceActive := .T.
		ELSE					// Otherwise, device 2^i is inactive
			lDeviceActive := .F.
		ENDIF

		IF nDevice = nExp		// Check for valid argument (Enable)
			lGoodArg := .T.
			nInitDevices += IIF( lDeviceActive, 0, nExp )
								// Check for valid argument (Disable)
		ELSEIF nDevice = nExp * -1
			lGoodArg := .T.
			nInitDevices -= IIF( lDeviceActive, nExp, 0 )
		ENDIF

	NEXT i
								// Bad argument returns zero
	RETURN IIF( lGoodArg, nInitDevices, 0 )
ENDIF

