*-------------------------------------------------------------------------
FUNCTION di_SAY(nTop,nLeft,cString,cPict,cColor)	// --> nSuccessList
*-------------------------------------------------------------------------
//-- Replacement for @..SAY command to output to multiple device types
	* Parameters are Top, Left, String, [Picture], [Color]
	* Returns the list of devices successfully written to

LOCAL nSuccessList := 0, i, j, nExp, nBeg, nEnd, nLast, nOutputList,  ;
		cMarker, cPage, cEnd, lPrev

								// If no arguments, do nothing, return 0
IF EMPTY(nTop) .OR. EMPTY(nLeft) .OR. EMPTY(cString)
	RETURN 0
ENDIF

nOutputList := di_SetOutput()	// For each device, check status
								// If device 1 (screen) outputs, implement
								//    a standard @..SAY block
IF nOutputList/2 <> INT(nOutputList/2)
								// Make sure SAY is  within screen area
	IF  (nTop >= 0) .AND. (nTop <= MAXROW()) .AND. ;
		(nLeft>= 0) .AND. (nLeft<= MAXCOL())
		nSuccessList += 1		// Add screen to nSuccessList
								// Fill in generic values if cPict
								//    or cColor are empty
		cColor:= IIF( EMPTY(cColor), SETCOLOR(), cColor )
		IF EMPTY(cPict)
			@ nTop,nLeft SAY cString COLOR cColor
		ELSE
			@ nTop,nLeft SAY cString PICTURE cPict COLOR cColor
		ENDIF
	ENDIF
ENDIF
								// If nOutputList happens to have any reserved
								//   devices beyond HTML, remove them
nOutputList := _diJustHTML(nOutputList)
								// For each HTML device, do the SAY
								// Apply any Picture code
cString := IIF( EMPTY(cPict), cString, TRANSFORM(cString,cPict) )
								// Translate any special characters in cString
cString := di_HTMLChars(cString)
								// Step through possible HTML devices
FOR i = MaxHTMLDevice TO 1 STEP -1
								// If device 2^i set to output, remove
								// 2^i from the output list and proceed
								// with attempted modification
	IF nOutputList >= (nExp := 2^i)
		nOutputList -= nExp		// Decrement nOutputlist and fetch the page
		cPage := _diHTMLEdit(nExp)
		lPrev := .F.			// Assume no relevant marker found

								// First look for position marker nTop
		cMarker := "<!-- "+STR(nTop,3)
		nLast := 0				// Set last such marker to 0
		cEnd := cPage			// Loop while we keep finding cMarker
		DO WHILE 0 <> (nBeg := AT(cMarker,cEnd))
			IF VAL(SUBSTR(cEnd,nBeg+8,3)) < nLeft
				nLast += nBeg	// If this marker has lower column than nLeft,
								//	  need to keep looking for later marker
			ENDIF
								// Set cEnd to end part of cString (of last cEnd)
			cEnd := SUBSTR(cEnd,nBeg+14)
		ENDDO
		IF nLast <> 0			// If we found a matching row, with lower
								//    matching column, write cString there
			lPrev := .T.
			cPage := SUBSTR(cPage,1,nLast+14) + crlf + cString + ;
					"<!-- " + STR(nTop,3)+STR(nLeft,3)+ " -->" + ;
					SUBSTR(cPage,nLast+15)
			cPage := _diHTMLEdit(nExp,cPage)
		ENDIF

								// Next look for position marker < nTop
		j := nTop				// Start looking from specified row
								// Try to find previous position maker
		DO WHILE j-- > 0 .AND. .NOT. lPrev
			cMarker := "<!-- "+STR(j,3)
			IF 0 <> (nBeg := AT(cMarker,cPage))
				lPrev := .T.
				cPage := SUBSTR(cPage,1,nBeg+14) + crlf + "<P>"+ cString + ;
						"<!-- " + STR(nTop,3)+STR(nLeft,3)+ " -->" + ;
						SUBSTR(cPage,nBeg+15)
				cPage := _diHTMLEdit(nExp,cPage)
			ENDIF
		ENDDO
							// Last put cString at begining of page
		IF .NOT. lPrev		// If no position marker, use '<BODY>'
			cMarker := "<BODY>"
			IF 0 <> (nBeg := AT(cMarker,cPage))
				lPrev := .T.
				cPage := SUBSTR(cPage,1,nBeg+5) + crlf + "<P>" + cString + ;
						"<!-- " + STR(nTop,3)+STR(nLeft,3)+ " -->" + ;
						SUBSTR(cPage,nBeg+6)
				cPage := _diHTMLEdit(nExp,cPage)
			ENDIF
		ENDIF
							// If something found for starting marker,
							//   add current page to nSuccessList
		nSuccessList += IIF( lPrev, nExp, 0)
	ENDIF
NEXT i

RETURN nSuccessList
