*-------------------------------------------------------------------------
FUNCTION di_setOutput(nNewDevices)		// --> nSelectedDevices
*-------------------------------------------------------------------------
//-- Set output to specified device(s): --
	* Devices are numbered 1, 2, 4, 8, ... 2^n
	* Device 1 is reserved for the screen
	* Devices 2 - 2^20 currently used for HTML output
	* Devices > 2^20 reserved for future uses
	* Parameter is sum of devices selected (i.e. 1+4+8 = 13)
	* Returns value of output device sum (no change if empty argument)

STATIC nSelectedDevices := 1
LOCAL i, nExp

*** ? "di_setOutput(",nNewDevices,")"

IF .NOT. EMPTY(nNewDevices)		// Empty arg returns existing output state
	nSelectedDevices := 0		// Calculate nSelectedDevices based on
								//    availability of requested devices
	FOR i = MaxDevices TO 0 STEP -1
		nExp := 2^i
		IF nNewDevices >= nExp
			nNewDevices -= nExp
			nSelectedDevices += IIF( _diActiveDevice(nExp), nExp, 0 )
		ELSE
			nSelectedDevices += 0
		ENDIF
	NEXT i
ENDIF
RETURN nSelectedDevices
